/*
*  Copyright 2019-2020 Zheng Jie
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*  http://www.apache.org/licenses/LICENSE-2.0
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*/
package com.youchain.businessdata.service;

import com.youchain.annotation.Log;
import com.youchain.businessdata.domain.AgvTask;
import com.youchain.businessdata.service.dto.AgvTaskDto;
import com.youchain.businessdata.service.dto.AgvTaskQueryCriteria;
import io.swagger.annotations.Api;
import org.springframework.data.domain.Pageable;
import java.util.Map;
import java.util.List;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

/**
* @website https://eladmin.vip
* @description 服务接口
* @author baobinglin
* @date 2023-08-18
**/
public interface AgvTaskService {

    /**
    * 查询数据分页
    * @param criteria 条件
    * @param pageable 分页参数
    * @return Map<String,Object>
    */
    Map<String,Object> queryAll(AgvTaskQueryCriteria criteria, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param criteria 条件参数
    * @return List<AgvTaskDto>
    */
    List<AgvTaskDto> queryAll(AgvTaskQueryCriteria criteria);

    /**
     * 根据ID查询
     * @param id ID
     * @return AgvTaskDto
     */
    AgvTaskDto findById(Integer id);

    /**
    * 创建
    * @param resources /
    * @return AgvTaskDto
    */
    AgvTaskDto create(AgvTask resources);

    /**
    * 编辑
    * @param resources /
    */
    void update(AgvTask resources);

    /**
    * 多选删除
    * @param ids /
    */
    void deleteAll(Integer[] ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    void download(List<AgvTaskDto> all, HttpServletResponse response) throws IOException;

    /**
     * 发送货架搬运接口任务
     * @param agvTasks
     * @return
     */
    String sendAgvTaskImpl(AgvTask agvTasks);

    /**
     * 发送料箱搬运接口任务
     * @param agvTasks
     * @return
     */
    public String sendAgvTaskLXImpl(List<AgvTask> agvTasks);

    /**
     * 发送滚筒搬运接口任务
     * @param agvTasks1-满箱任务
     * @param agvTasks1-控销任务
     * @return
     */
    public String sendAgvTaskGTImpl(List<AgvTask> agvTasks1,List<AgvTask> agvTasks2);

    /**
     * 查询容器状态
     * @param containerCode-容器编号
     * @return
     */
    String containerQuery(String containerCode);

    /**
     * 查询输送线上料箱总数
     * @param taskCode-输送线编号
     * @return
     */
    int QueryCount(String taskCode);

    AgvTask toEntity(AgvTaskDto agvTaskDto);

    /**
     * 任务回报更新状态
     * @param agvTask
     * @param status
     * @param containerCode
     */
    void agvTaskCallback(AgvTask agvTask,String status,String containerCode);

    boolean findByendSlotCode(String endSlotCode,String type,String jobType);

    List<AgvTask>  findById(List<Integer> ids);
}
